/* 
A comm link application based on:
	"Arrays of Pointers to Functions", NIGEL JONES, Embedded Systems Programming, p 46, May 99
*/

#include <REG51.H>
#include "defines.h"
#include <string.h>

#define N_HANDLER   0x09
#define ERROR_FAIL  0xC1
#define C_SUCCESS   0xC2
#define N_CMDREPEAT
				  
/** define a array of function pointers; locate into PROM */
const char (*const code read_fns[N_HANDLER])(void) = {hdr00, hdr01, hdr02, hdr10, hdr11, hdr12, hdr20, hdr21, hdr22};
char code read_str[] = "OOSSVVNNWWFF";

/**
Function handels a new incoming keyCode form the keyboard
*/
UINT8 process_read(UINT8* position){
	char *cmdptr;
	UINT8 offset;
	char replyChar;

 	if(position > (sizeof(read_str)+read_str)){
	  return 0;
	}		 

	offset = (position + 1 - read_str) >> 1;
	replyChar = (*read_fns[offset])();
}

void main(void)
{
 volatile UINT8 *pos;
 /** initialize port to input */
 P1 = 0xFF;  	
 pos = read_str + P1;

	while(1) {
		process_read(pos);	
	} 
}