#include <8051.h>
#include <string.h>

#define N_ZEILEN	3
#define N_SPALTEN	3
#define ERROR_FAIL  	0xC1
#define C_SUCCESS   	0xC2
#define N_HANDLER 	0x09

typedef unsigned char UINT8;
typedef unsigned int UINT16;

/** define a array of function pointers; locate into PROM */
const char (*const code read_fns[N_HANDLER])(void) = {hdr00, hdr01, hdr02, hdr10, hdr11, hdr12, hdr20, hdr21, hdr22};
char code read_str[] = "OOSSVVNNWWFF";


UINT8 process_read(UINT8* position){
  char offset;
  char replyChar;

  if(position > (sizeof(read_str)+read_str)){
    return 0;
  }		 
  offset = (position + 1 - read_str) >> 1;
  replyChar = (*read_fns[offset])();

}
  
void main(void)
{
 volatile UINT8 *pos;
 /** initialize port to input */
 P1 = 0xCC;  	
 pos = read_str+P1;

	while(1) {
		process_read(pos);	
	} 
}
 
const char hdr00(void){
_asm;
	MOV A, #0x00
_endasm;
	return 'X';
}

const char hdr01(void){
_asm;
	MOV A, #0x01
_endasm;
	return 'I';
}

const char hdr02(void){
_asm;
	MOV A, #0x02
_endasm;
	return 'A';
}

const char hdr10(void){
_asm;
	MOV A, #0x10
_endasm;
	return 'O';
}

const char hdr11(void){
_asm;
	MOV A, #0x11
_endasm;
	return 'T';
}

const char hdr12(void){
_asm;
	MOV A, #0x12
_endasm;
	return 'A';
}

const char hdr20(void){
_asm;
	MOV A, #0x20
_endasm;
	return 'I';
}

const char hdr21(void){
_asm;
	MOV A, #0x21
_endasm;
	return 'X';
}

const char hdr22(void){
_asm;
	MOV A, #0x22
_endasm;
	return 'I';
}