/* 
A keyboard application based:
	"Arrays of Pointers to Functions", NIGEL JONES, Embedded Systems Programming, p 46, May 99
*/

#include <REG51.H>
#include "defines.h"

#define N_ZEILEN	3
#define N_SPALTEN	3
#define ERROR_FAIL  0xC1
#define C_SUCCESS   0xC2

/** define a array of function pointers; locate into PROM */
const UINT8 (*const code pf[N_ZEILEN][N_SPALTEN])(void) = {
{hdr00, hdr01, hdr02},
{hdr10, hdr11, hdr12},
{hdr20, hdr21, hdr22}};
 
/**
Function handels a new incoming keyCode form the keyboard
*/
UINT8 keypress(UINT8 zeile, UINT8 spalte){

	/** Function pointer array. This will be located in the RAM */

	if(zeile >= N_ZEILEN){
		return ERROR_FAIL;
	}
	if(spalte >= N_SPALTEN){
		return ERROR_FAIL;
	}
	/** Call the corresponding handler function and return */
	return(*pf[zeile][spalte])();
}

void main(void)
{
	UINT8 keyInput;
	UINT8 keyInput2;

	/** initialize port to input */
	P1 = 0xFF;
	P2 = 0xFF;
	  	
	while(1) {
	    /** Read Keyboard value from IO */
		keyInput = P1;
		keyInput2 = P2;
		/** make some fancy calculations here */
		
		/** now call the correspoding keyboard handler */
		keypress(keyInput,keyInput2);		
	} 
}