#include <8051.h>

#define N_ZEILEN	3
#define N_SPALTEN	3
#define ERROR_FAIL  0xC1
#define C_SUCCESS   0xC2

typedef unsigned char UINT8;
typedef unsigned int UINT16;

/** define a array of function pointers; locate into PROM */
const UINT8 (*const code pf[N_ZEILEN][N_SPALTEN])(void) = {
{hdr00, hdr01, hdr02},
{hdr10, hdr11, hdr12},
{hdr20, hdr21, hdr22}};

UINT8 keypress(UINT8 zeile, UINT8 spalte){
 
	if(zeile >= N_ZEILEN){
		return ERROR_FAIL;
	}
	if(spalte >= N_SPALTEN){
		return ERROR_FAIL;
	}
	/** Call the corresponding handler function and return */
	return(*pf[zeile][spalte])();
  
}
  
void main()
{
	UINT8 keyInput;
	UINT8 keyInput2;

	/** initialize port to input */
	P1 = 0xFF;
	P2 = 0xFF;
	  	
	while(1) {
	    /** Read Keyboard value from IO */
		keyInput = P1;
		keyInput2 = P2;
		/** make some fancy calculations here */
		
		/** now call the correspoding keyboard handler */
		keypress(keyInput,keyInput2);		
	} 
}
 

unsigned char hdr00(void){
_asm;
	MOV A, #0x00
_endasm;
	return C_SUCCESS;
}

unsigned char hdr01(void){
_asm;
	MOV A, #0x01
_endasm;
	return C_SUCCESS;
}

unsigned char hdr02(void){
_asm;
	MOV A, #0x02
_endasm;
	return C_SUCCESS;
}

unsigned char hdr10(void){
_asm;
	MOV A, #0x10
_endasm;
	return C_SUCCESS;
}

unsigned char hdr11(void){
_asm;
	MOV A, #0x11
_endasm;
	return C_SUCCESS;
}

unsigned char hdr12(void){
_asm;
	MOV A, #0x12
_endasm;
	return C_SUCCESS;
}

unsigned char hdr20(void){
_asm;
	MOV A, #0x20
_endasm;
	return C_SUCCESS;
}

unsigned char hdr21(void){
_asm;
	MOV A, #0x21
_endasm;
	return C_SUCCESS;
}

unsigned char hdr22(void){
_asm;
	MOV A, #0x22
_endasm;
	return C_SUCCESS;
}