/* 
A single row input application based on:
	"Arrays of Pointers to Functions", NIGEL JONES, Embedded Systems Programming, p 46, May 99
*/

#include <REG51.H>
#include "defines.h"

/** define a array of function pointers; locate into PROM */
const UINT8 (*const code pf[])(void) = {hdr1, hdr2, hdr3, hdr4, hdr5, hdr6};
 
/**
Function handels a new incoming keyCode form the keyboard
*/
UINT8 keypress(UINT8 keyCode){

	/** Function pointer array. This will be located in the RAM */

	if(keyCode >= N_KEYS){
		return ERROR_FAIL;
	}
	
	/** Call the corresponding handler function and return */
	return(*pf[keyCode])();
}

void main(void)
{
	UINT8 keyInput;

	/** initialize port to input */
	P1 = 0xFF;
	
	while(1) {
	    /** Read Keyboard value from IO */
		keyInput = P1;
		
		/** now call the correspoding keyboard handler */
		keypress(keyInput);		
	} 
}