/* 
A task scheduler application based on:
	"Arrays of Pointers to Functions", NIGEL JONES, Embedded Systems Programming, p 46, May 99
*/

#include <REG51.H>
#include "defines.h"

#define ERROR_FAIL  0xC1
#define C_SUCCESS   0xC2
#define N_CMDREPEAT
		
#define INTERVAL_16_MSEC  16
#define INTERVAL_50_MSEC  50
#define INTERVAL_100_MSEC 100
#define INTERVAL_150_MSEC 150
#define INTERVAL_200_MSEC 200
						  				  
typedef struct{
 	UINT8 interval;
	void (*proc)(void);
}TIMED_TASK;

code const TIMED_TASK timed_task[]=
{
  {INTERVAL_16_MSEC, task1},
  {INTERVAL_50_MSEC, task2},
  {INTERVAL_100_MSEC, task3},
  {INTERVAL_150_MSEC, task4},
  {INTERVAL_200_MSEC, task5},
  {0x0, 0x0}
};

									  
void main(void)
{
 volatile UINT8 time;
 const TIMED_TASK *ptr;

 /** initialize port to input */
 P1 = 0xFF;  	

	while(1) {
	 time = P1 ;
		for(ptr = timed_task; ptr->interval != 0; ptr++){
			if((time == ptr->interval))
				(ptr->proc)(); // Call the task
		}								   
	} 
}